#ifndef CPRIORITYQUE
#define CPRIORITYQUE

template <class Item>
class CPriorityQue
{

  private:
		Item* myQue;
		unsigned int size;
		unsigned int max;
		int act;
		
  public:
		
		enum Exceptions {EQueIsFull, EQueIsEmpty};
		
	  CPriorityQue(unsigned int k);
	  ~CPriorityQue();
	  
	  void push(Item e);
	  void pop(Item &e);
	  bool isEmpty();
	  Item first();
};

template <class Item>
CPriorityQue<Item>::CPriorityQue(unsigned int k)
{
  act=-1;
  max=0;
  size=k;
  myQue = new Item[size];
};

template <class Item>
CPriorityQue<Item>::~CPriorityQue()
{
  delete[] myQue;
};

template <class Item>
void CPriorityQue<Item>::push(Item e)
{
  if (size==act+1)
  {
	  throw EQueIsFull;
  }
  else
  {
		act+=1;
		myQue[act]=e;
		if (act!=0)
		{
      if (e>myQue[max])
      {
	      max=act;
	    }
	  }
	  else
	  {
      max=0;
    }
  }
};

template <class Item>
void CPriorityQue<Item>::pop(Item &e)
{
  if (!isEmpty())
  {
	 	e=myQue[max];
	 	myQue[max]=myQue[act];
	 	act-=1;
	 	max=0;
	 	for (int i=1; i<act; i++)
	 	{
 		  if (myQue[i]>myQue[max]) max=i;
 		}
	}
	else
  {
	  throw EQueIsEmpty;
  }
};

template <class Item>
bool CPriorityQue<Item>::isEmpty()
{
  return (act==-1);
};

template <class Item>
Item CPriorityQue<Item>::first()
{
  if (!isEmpty())
  {
	  return myQue[max];
  }
  else
  {
	  throw EQueIsEmpty;
  }
};

#endif
