#ifndef CSTATION
#define CSTATION
#include "CSeqInFile.hpp"
#include "CSeqOutFile.hpp"
#include "CPriorityQue.hpp"
#include "CTrain.hpp"

class CStation
{
 			
  private:
					
    CPriorityQue<CTrain>*      station;
		CSeqInFile<CTrain>*        input;
		CSeqOutFile<unsigned int>* output;
		
  public:
				 
	  CStation(const std::string InFileName, const std::string OutFileName, unsigned int NumberOfPlatforms)
	  {
	    station = new CPriorityQue<CTrain>       (NumberOfPlatforms);
			input   = new CSeqInFile<CTrain>         (InFileName);
			output  = new CSeqOutFile<unsigned int>  (OutFileName);
		} // end of constructor
		
	  ~CStation() 
		{
		  delete station;
		  delete input;
		  delete output;
		} // end of destructor
		
	  void Do()
	  {
      CTrain trainRead;
      CTrain dummy;
      
			input->first();
 	    trainRead = input->current();
			while ((!station->isEmpty()) && (trainRead > station->first()))
			{
			  station->pop(dummy);
			  if (station->isEmpty()) continue;
			}
			try
			{
			 	station->push(trainRead);
		  }
			catch (...)
			{
 			  output->write(trainRead.trainId);
			}
			
			while(!input->end())
			{
				input->read();
			  trainRead = input->current();

				while ((!station->isEmpty()) && (trainRead > station->first()))
				{
			    station->pop(dummy);
			    if (station->isEmpty()) continue;
				}
				try
				{
				 	station->push(trainRead);
			  }
				catch (...)
				{
 			    output->write(trainRead.trainId);
			  }
			}
	  } // end of main procedure do
};

#endif
